#include "stdafx.h"
#include "LifeByConvey.h"

#define MAX_LOADSTRING 100

//  :
HINSTANCE hInst;								//  
TCHAR szTitle[MAX_LOADSTRING];					//   
TCHAR szWindowClass[MAX_LOADSTRING];			//    

//   ,     :
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
                     _In_opt_ HINSTANCE hPrevInstance,
                     _In_ LPTSTR    lpCmdLine,
                     _In_ int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO:   .
	MSG msg;
	HACCEL hAccelTable;

	//   
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_LIFEBYCONVEY, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	//   :
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_LIFEBYCONVEY));

	//   :
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  : MyRegisterClass()
//
//  :   .
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_LIFEBYCONVEY));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_LIFEBYCONVEY);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   : InitInstance(HINSTANCE, int)
//
//   :       .
//
//   :
//
//                ,  
//               .
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; //      

   hWnd = CreateWindow(szWindowClass, szTitle, 
	   WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_DLGFRAME,
       CW_USEDEFAULT, 0, 
	   M*D+2*GetSystemMetrics(SM_CXEDGE)+12, 
	   N*D+2*GetSystemMetrics(SM_CYEDGE)+
	   GetSystemMetrics(SM_CYCAPTION)+
	   GetSystemMetrics(SM_CYMENU)+12, 
	   NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  : WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  :      .
//
//  WM_COMMAND	-   
//  WM_PAINT	-  
//  WM_DESTROY	 -      .
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	static HPEN GrayPen; //  
	HPEN PrevPen;        //  
	static HBRUSH BlackBrush; //  
	HBRUSH PrevBrush;   //  
	int x,y;
	RECT R;
	static bool running = false;
	WCHAR s[128];
	bool rs;
	OPENFILENAME ofn; //   OpenFile
    WCHAR filename[4096]; //     
    WCHAR Title[512];  //     
	static int DT = 100; //  

	
	switch (message)
	{

	case WM_CREATE:
		InitLife(M,N);
		GrayPen=CreatePen(PS_SOLID,1,RGB(127,127,127));
		BlackBrush=(HBRUSH) GetStockObject(BLACK_BRUSH);
		SetWindowText(hWnd,L"Convey Life");
		break;
	case WM_MOUSEWHEEL:
		if (running)
		{
		 x=GET_WHEEL_DELTA_WPARAM(wParam);
		 if (x<0) if (DT>20) DT-=10;
		 if (x>0) if (DT<1000) DT+=10;
		 KillTimer(hWnd,1);
		 SetTimer(hWnd,1,DT,NULL);
		}
		
		break;
	case WM_KEYDOWN:
		rs=false;

		switch(wParam)
		{
		case VK_RIGHT:	
			if (D*M<GetSystemMetrics(SM_CXVIRTUALSCREEN)) 
			{ M+=10; rs=true; }	break;
		case VK_LEFT:	if (M>=30) M-=10; rs=true;		break;
		case VK_UP:		if (N>=30) N-=10; rs=true;		break;
		case VK_DOWN:	
			if (D*N<GetSystemMetrics(SM_CYVIRTUALSCREEN)) 
			{ N+=10; rs=true; }	break;
		case VK_ADD:	D++; rs=true;					break;
		case VK_SUBTRACT:		if (D>5) D--; rs=true;	break;
		}
		if (rs)	
		{   InitLife(M,N);
			MoveWindow(hWnd,10,10,
	             M*D+2*GetSystemMetrics(SM_CXEDGE)+12, 
				 N*D+2*GetSystemMetrics(SM_CYEDGE)+
				       GetSystemMetrics(SM_CYCAPTION)+
					   GetSystemMetrics(SM_CYMENU)+12,true);
		}
		break;
	case WM_TIMER:
		 step();
		 InvalidateRect(hWnd,NULL,false);
 		 wsprintf(s,L"Convey Life, Generation %d",Generation);
		 SetWindowText(hWnd,s);
		break;
	case WM_LBUTTONDOWN:
          x=LOWORD(lParam)/D; y=HIWORD(lParam)/D;
		  if (x>=0 && x<M && y>=0 && y<N)
		  {
			  if (A[Z(x,y)]) A[Z(x,y)]=0; else A[Z(x,y)]=1;
			  R.left=x*D;       R.top=y*D;
			  R.right=R.left+D; R.bottom=R.top+D;
			  InvalidateRect(hWnd,&R,false);
		  }
		break;
	case WM_MOUSEMOVE:
		if (wParam==MK_LBUTTON || wParam==MK_RBUTTON)
		{
          x=LOWORD(lParam)/D; y=HIWORD(lParam)/D;
		  if (x>=0 && x<M && y>=0 && y<N)
		  {
			  if (wParam==MK_LBUTTON) A[Z(x,y)]=1; 
			  else A[Z(x,y)]=0;
			  R.left=x*D;       R.top=y*D;
			  R.right=R.left+D; R.bottom=R.top+D;
			  InvalidateRect(hWnd,&R,false);
		  }

		}
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		//    :
		switch (wmId)
		{
		case ID_OPEN:
         ofn.lStructSize=sizeof(OPENFILENAME);
         ofn.hwndOwner=hWnd; // -
         ofn.lpstrFilter=L"Convey Life\0*.life\0All files\0*.*\0"; //  
         ofn.lpstrCustomFilter=NULL; //  
         ofn.nFilterIndex=1; //  
         filename[0]='\0'; //     0 ( )
         ofn.lpstrFile=filename; //     
         ofn.nMaxFile=sizeof(filename)-1;
         ofn.lpstrFileTitle=Title; //   - 
         ofn.nMaxFileTitle=sizeof(Title)-1;
         ofn.lpstrInitialDir=NULL; //   - 
         ofn.lpstrTitle=L"Open Convey Life file"; //  
         ofn.Flags = OFN_LONGNAMES | OFN_FILEMUSTEXIST; // 
         ofn.lpstrDefExt=L"life"; //   
         if (GetOpenFileName(&ofn))
         { 
			 FILE *f = _wfopen(filename,L"rt");
			 if (f)
			 {   InitLife(M,N); 
				 while (!feof(f))
				{
					fscanf(f,"%d %d",&x,&y);
					if (x>=0 && x<M && y>=0 && y<M)
						A[Z(x,y)]=1;
				}
				 fclose(f);
				 InvalidateRect(hWnd,NULL,false);
			 }
         }
		break;
		case ID_SAVE:
         ofn.lStructSize=sizeof(OPENFILENAME);
         ofn.hwndOwner=hWnd; // -
         ofn.lpstrFilter=L"Convey Life\0*.life\0All files\0*.*\0"; //  
         ofn.lpstrCustomFilter=NULL; //  
         ofn.nFilterIndex=1; //  
         filename[0]='\0'; //     0 ( )
         ofn.lpstrFile=filename; //     
         ofn.nMaxFile=sizeof(filename)-1;
         ofn.lpstrFileTitle=Title; //   - 
         ofn.nMaxFileTitle=sizeof(Title)-1;
         ofn.lpstrInitialDir=NULL; //   - 
         ofn.lpstrTitle=L"Open Convey Life file"; //  
         ofn.Flags = OFN_LONGNAMES ; // 
         ofn.lpstrDefExt=L"life"; //   
         if (GetSaveFileName(&ofn))
         { 
			 FILE *f = _wfopen(filename,L"wt");
			 if (f)
			 {   for (int i=0; i<M; i++)
			      for (int j=0; j<N; j++)
					  if (A[Z(i,j)]) fprintf(f,"%d %d\n",i,j);
				 fclose(f);
			 }
         }
		break;
		case ID_STARTSTOP:
			if (running) { KillTimer(hWnd,1); running=false; }
			else {  SetTimer(hWnd,1,DT,NULL); running=true;  }
			break;
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		PrevPen=(HPEN) SelectObject(hdc,GrayPen);
		for (int i=0; i<M; i++)
			for (int j=0; j<N; j++)
			{
			  if (A[Z(i,j)]) PrevBrush=(HBRUSH) SelectObject(hdc,BlackBrush);
			  Rectangle(hdc,i*D,j*D,(i+1)*D+1,(j+1)*D+1);
			  if (A[Z(i,j)]) SelectObject(hdc,PrevBrush);
			}
		SelectObject(hdc,PrevPen);
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		DeleteObject(GrayPen);
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

//     " ".
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
